using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Threading;
using System.IO.Ports;

namespace WindowsApplication1
{
	public partial class Form1 : Form
	{
		static bool _continue;
		static Thread readThread;
		static SerialPort _serialPort1;

		public Form1()
		{
			InitializeComponent();
		}

		private void Form1_Load(object sender, EventArgs e)
		{
			_serialPort1 = new SerialPort();

			_serialPort1.BaudRate = 19200;
			_serialPort1.PortName = "com1";

			_serialPort1.ReadTimeout = 500;
			_serialPort1.WriteTimeout = 500;

			_serialPort1.Open();

			_serialPort1.DtrEnable = true; // power line for level converter

			_continue = true;

			readThread = new Thread(new ParameterizedThreadStart(ReadPort));
			readThread.Start(listBox1);
		}

		private void Form1_FormClosed(object sender, FormClosedEventArgs e)
		{
			_continue = false;

			readThread.Join();

			_serialPort1.Close();
		}

		private void SetFreq(long new_freq)
		{
			byte[] fdata = new byte[100]                                                                                                                                  
            {0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,0x10,0x11,0x12,0x13,0x14,                                                                                 
            0x15,0x16,0x17,0x18,0x19,0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,0x28,0x29,0x30,0x31,0x32,                                                                   
            0x33,0x34,0x35,0x36,0x37,0x38,0x39,0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,0x48,0x49,0x50,                                                                   
            0x51,0x52,0x53,0x54,0x55,0x56,0x57,0x58,0x59,0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,0x68,                                                                   
            0x69,0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,0x78,0x79,0x80,0x81,0x82,0x83,0x84,0x85,0x86,                                                                   
            0x87,0x88,0x89,0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,0x98,0x99};

			byte[] Result = new byte[5];
			long input = new_freq;

			Result[0] = (byte)(input % 100);
			input = input / 100;
			Result[1] = (byte)(input % 100);
			input = input / 100;
			Result[2] = (byte)(input % 100);
			input = input / 100;
			Result[3] = (byte)(input % 100);
			input = input / 100;
			Result[4] = (byte)(input % 100);

			byte[] buffer = new byte[11] { 
                0xFE, //Sync
                0xFE, //Sync
                0x6C, //Addr Receiver
                0x0E, //Addr Controller
                0x00, //Write Freq 
                fdata[Result[0]],
                fdata[Result[1]],
                fdata[Result[2]],
                fdata[Result[3]],
                fdata[Result[4]], 
                0xFD }; //End operation

			_serialPort1.Write(buffer, 0, buffer.Length);
		}

		public static void ReadPort(object obj)
		{
			while (_continue)
			{
				try
				{
					byte[] buffer = new byte[1];
					_serialPort1.Read(buffer, 0, 1);

					ListBox lb = (ListBox)obj;
					lb.Items.Add(buffer[0].ToString("X2"));
					lb.SetSelected(lb.Items.Count - 1, false);
				}
				catch (TimeoutException) { }
			}
		}

		private void button1_Click(object sender, EventArgs e)
		{
			for (int i = 150000000; i < 151000000; i += 12500)
			{
				SetFreq(i);
				System.Threading.Thread.Sleep(100);
			}
		}

		private void button2_Click(object sender, EventArgs e)
		{
			listBox1.Items.Clear();
		}
	}
}